require '_h2ph_pre.ph';

no warnings qw(redefine misc);

require 'machine/endian_machdep.ph';
if((defined(&_BYTE_ORDER) ? &_BYTE_ORDER : undef) == (defined(&_LITTLE_ENDIAN) ? &_LITTLE_ENDIAN : undef)) {
    eval 'sub ELF32_MACHDEP_ENDIANNESS () { &ELFDATA2LSB;}' unless defined(&ELF32_MACHDEP_ENDIANNESS);
} else {
    eval 'sub ELF32_MACHDEP_ENDIANNESS () { &ELFDATA2MSB;}' unless defined(&ELF32_MACHDEP_ENDIANNESS);
}
eval 'sub ELF32_MACHDEP_ID_CASES () { &case  &EM_SH:  &break;;}' unless defined(&ELF32_MACHDEP_ID_CASES);
eval 'sub ELF64_MACHDEP_ENDIANNESS () { &XXX;}' unless defined(&ELF64_MACHDEP_ENDIANNESS);
eval 'sub ELF64_MACHDEP_ID_CASES () {1;}' unless defined(&ELF64_MACHDEP_ID_CASES);
eval 'sub ELF32_MACHDEP_ID () { &EM_SH;}' unless defined(&ELF32_MACHDEP_ID);
eval 'sub KERN_ELFSIZE () {32;}' unless defined(&KERN_ELFSIZE);
eval 'sub ARCH_ELFSIZE () {32;}' unless defined(&ARCH_ELFSIZE);
eval 'sub EF_SH_MACH_MASK () {0x1f;}' unless defined(&EF_SH_MACH_MASK);
eval 'sub EF_SH_UNKNOWN () {0x;}' unless defined(&EF_SH_UNKNOWN);
eval 'sub EF_SH_SH1 () {0x1;}' unless defined(&EF_SH_SH1);
eval 'sub EF_SH_SH2 () {0x2;}' unless defined(&EF_SH_SH2);
eval 'sub EF_SH_SH3 () {0x3;}' unless defined(&EF_SH_SH3);
eval 'sub EF_SH_DSP () {0x4;}' unless defined(&EF_SH_DSP);
eval 'sub EF_SH_SH3_DSP () {0x5;}' unless defined(&EF_SH_SH3_DSP);
eval 'sub EF_SH_SH3E () {0x8;}' unless defined(&EF_SH_SH3E);
eval 'sub EF_SH_SH4 () {0x9;}' unless defined(&EF_SH_SH4);
eval 'sub EF_SH_HAS_DSP {
    my($x) = @_;
	eval q((($x) &  &EF_SH_DSP));
}' unless defined(&EF_SH_HAS_DSP);
eval 'sub EF_SH_HAS_FP {
    my($x) = @_;
	eval q((($x) &  &EF_SH_SH3E));
}' unless defined(&EF_SH_HAS_FP);
eval 'sub R_SH_NONE () {0;}' unless defined(&R_SH_NONE);
eval 'sub R_SH_DIR32 () {1;}' unless defined(&R_SH_DIR32);
eval 'sub R_SH_REL32 () {2;}' unless defined(&R_SH_REL32);
eval 'sub R_SH_DIR8WPN () {3;}' unless defined(&R_SH_DIR8WPN);
eval 'sub R_SH_IND12W () {4;}' unless defined(&R_SH_IND12W);
eval 'sub R_SH_DIR8WPL () {5;}' unless defined(&R_SH_DIR8WPL);
eval 'sub R_SH_DIR8WPZ () {6;}' unless defined(&R_SH_DIR8WPZ);
eval 'sub R_SH_DIR8BP () {7;}' unless defined(&R_SH_DIR8BP);
eval 'sub R_SH_DIR8W () {8;}' unless defined(&R_SH_DIR8W);
eval 'sub R_SH_DIR8L () {9;}' unless defined(&R_SH_DIR8L);
eval 'sub R_SH_LOOP_START () {10;}' unless defined(&R_SH_LOOP_START);
eval 'sub R_SH_LOOP_END () {11;}' unless defined(&R_SH_LOOP_END);
eval 'sub R_SH_GNU_VTINHERIT () {22;}' unless defined(&R_SH_GNU_VTINHERIT);
eval 'sub R_SH_GNU_VTENTRY () {23;}' unless defined(&R_SH_GNU_VTENTRY);
eval 'sub R_SH_SWITCH8 () {24;}' unless defined(&R_SH_SWITCH8);
eval 'sub R_SH_SWITCH16 () {25;}' unless defined(&R_SH_SWITCH16);
eval 'sub R_SH_SWITCH32 () {26;}' unless defined(&R_SH_SWITCH32);
eval 'sub R_SH_USES () {27;}' unless defined(&R_SH_USES);
eval 'sub R_SH_COUNT () {28;}' unless defined(&R_SH_COUNT);
eval 'sub R_SH_ALIGN () {29;}' unless defined(&R_SH_ALIGN);
eval 'sub R_SH_CODE () {30;}' unless defined(&R_SH_CODE);
eval 'sub R_SH_DATA () {31;}' unless defined(&R_SH_DATA);
eval 'sub R_SH_LABEL () {32;}' unless defined(&R_SH_LABEL);
eval 'sub R_SH_TLS_GD_32 () {144;}' unless defined(&R_SH_TLS_GD_32);
eval 'sub R_SH_TLS_LD_32 () {145;}' unless defined(&R_SH_TLS_LD_32);
eval 'sub R_SH_TLS_LDO_32 () {146;}' unless defined(&R_SH_TLS_LDO_32);
eval 'sub R_SH_TLS_IE_32 () {147;}' unless defined(&R_SH_TLS_IE_32);
eval 'sub R_SH_TLS_LE_32 () {148;}' unless defined(&R_SH_TLS_LE_32);
eval 'sub R_SH_TLS_DTPMOD32 () {149;}' unless defined(&R_SH_TLS_DTPMOD32);
eval 'sub R_SH_TLS_DTPOFF32 () {150;}' unless defined(&R_SH_TLS_DTPOFF32);
eval 'sub R_SH_TLS_TPOFF32 () {151;}' unless defined(&R_SH_TLS_TPOFF32);
eval 'sub R_SH_GOT32 () {160;}' unless defined(&R_SH_GOT32);
eval 'sub R_SH_PLT32 () {161;}' unless defined(&R_SH_PLT32);
eval 'sub R_SH_COPY () {162;}' unless defined(&R_SH_COPY);
eval 'sub R_SH_GLOB_DAT () {163;}' unless defined(&R_SH_GLOB_DAT);
eval 'sub R_SH_JMP_SLOT () {164;}' unless defined(&R_SH_JMP_SLOT);
eval 'sub R_SH_RELATIVE () {165;}' unless defined(&R_SH_RELATIVE);
eval 'sub R_SH_GOTOFF () {166;}' unless defined(&R_SH_GOTOFF);
eval 'sub R_SH_GOTPC () {167;}' unless defined(&R_SH_GOTPC);
eval 'sub R_TYPE {
    my($name) = @_;
	eval q( &__CONCAT( &R_SH_,$name));
}' unless defined(&R_TYPE);
1;
