require '_h2ph_pre.ph';

no warnings qw(redefine misc);

unless(defined(&_SH3_FENV_H_)) {
    eval 'sub _SH3_FENV_H_ () {1;}' unless defined(&_SH3_FENV_H_);
    require 'sys/stdint.ph';
    require 'sh3/float.ph';
    require 'sh3/fpreg.ph';
    unless(defined(&__fenv_static)) {
	eval 'sub __fenv_static () { &static;}' unless defined(&__fenv_static);
    }
    eval 'sub FE_INEXACT () {(( &uint32_t) &FPSCR_EXCEPTION_INEXACT >> 5);}' unless defined(&FE_INEXACT);
    eval 'sub FE_DIVBYZERO () {(( &uint32_t) &FPSCR_EXCEPTION_ZERODIV >> 5);}' unless defined(&FE_DIVBYZERO);
    eval 'sub FE_UNDERFLOW () {(( &uint32_t) &FPSCR_EXCEPTION_UNDERFLOW >> 5);}' unless defined(&FE_UNDERFLOW);
    eval 'sub FE_OVERFLOW () {(( &uint32_t) &FPSCR_EXCEPTION_OVERFLOW >> 5);}' unless defined(&FE_OVERFLOW);
    eval 'sub FE_INVALID () {(( &uint32_t) &FPSCR_EXCEPTION_INVALID >> 5);}' unless defined(&FE_INVALID);
    eval 'sub FE_ALL_EXCEPT () {( &FE_INEXACT |  &FE_DIVBYZERO |  &FE_UNDERFLOW |  &FE_OVERFLOW |  &FE_INVALID);}' unless defined(&FE_ALL_EXCEPT);
    eval 'sub FE_TONEAREST () { &FPSCR_ROUND_NEAREST;}' unless defined(&FE_TONEAREST);
    eval 'sub FE_TOWARDZERO () { &FPSCR_ROUND_ZERO;}' unless defined(&FE_TOWARDZERO);
    eval 'sub FE_DOWNWARD () {( &FPSCR_ROUND_ZERO + 1);}' unless defined(&FE_DOWNWARD);
    eval 'sub FE_UPWARD () {( &FPSCR_ROUND_ZERO + 2);}' unless defined(&FE_UPWARD);
    eval 'sub _ROUND_MASK () {( &FE_TONEAREST |  &FE_TOWARDZERO);}' unless defined(&_ROUND_MASK);
    if(defined(&__SH_FPU_ANY__)) {
	eval 'sub FE_DFL_ENV () {(( &fenv_t *) -1);}' unless defined(&FE_DFL_ENV);
	eval 'sub __get_fpscr {
	    my($__fpscr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__get_fpscr);
	eval 'sub __set_fpscr {
	    my($__fpscr) = @_;
    	    eval q(\\"(assembly code)\\");
	}' unless defined(&__set_fpscr);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __fmul {
	    my($a,$b) = @_;
    	    eval q({ });
	}' unless defined(&__fmul);
# some #ifdef were dropped here -- fill in the blanks
	eval 'sub __fdiv {
	    my($a,$b) = @_;
    	    eval q({ });
	}' unless defined(&__fdiv);
	if(defined(&_NETBSD_SOURCE) || defined(&_GNU_SOURCE)) {
	    eval 'sub fedisableexcept {
	        my($__mask) = @_;
    		eval q({  &fexcept_t  &__fpscr,  &__oldmask;  &__get_fpscr( &__fpscr);  &__oldmask = ( &__fpscr >> 5) &  &FE_ALL_EXCEPT;  &__fpscr &= ~($__mask &  &FE_ALL_EXCEPT) << 5;  &__set_fpscr( &__fpscr);  &__oldmask; });
	    }' unless defined(&fedisableexcept);
	    eval 'sub fegetexcept {
	        my($void) = @_;
    		eval q({  &fexcept_t  &__fpscr;  &__get_fpscr( &__fpscr); ( &__fpscr >> 5) &  &FE_ALL_EXCEPT; });
	    }' unless defined(&fegetexcept);
	}
    }
}
1;
